--[[
	Created through the help of Xzandro XTimestamp AddOn
--]]

----------------------------------
-- Variables
----------------------------------
TCCN = {}

-- Constants
TCCN.NAME = 'TsChatColoringNeutralizer'

----------------------------------
-- Functions
----------------------------------
function TCCN.OnInitialized()
	-- Register events
	ZO_ChatSystem_AddEventHandler(EVENT_CHAT_MESSAGE_CHANNEL, TCCN.OnEventChatMessageChannel)
end

function TCCN.OnEventChatMessageChannel(messageType, fromName, text)
    local ChannelInfo = ZO_ChatSystem_GetChannelInfo()
    local channelInfo = ChannelInfo[messageType]
    if channelInfo and channelInfo.format then
        local channelLink = TCCN.CreateChannelLink(channelInfo)
        local fromLink = TCCN.CreateFromLink(fromName, channelInfo)
		text = TCCN.NeutralizeChatColor(text)
        if channelLink then
            return zo_strformat(channelInfo.format, channelLink, fromLink, text), channelInfo.saveTarget
        end
        return zo_strformat(channelInfo.format, fromLink, text), channelInfo.saveTarget
    end
end

function TCCN.CreateChannelLink(channelInfo, overrideName)
    if channelInfo.channelLinkable then
        local channelName = overrideName or GetChannelName(channelInfo.id)
        return ZO_LinkHandler_CreateChannelLink(channelName)
    end
end

function TCCN.CreateFromLink(fromName, channelInfo)
    if channelInfo.playerLinkable then
       return ZO_LinkHandler_CreatePlayerLink(fromName)
    end
    return fromName
end

function TCCN.NeutralizeChatColor(text)
	-- remove all color codes
	local found = string.find(text, "|c")
	while found ~= nil do
		local first = string.utf8sub(text, 1, found-1)
		local last = string.utf8sub(text, found+8, string.utf8len(text))
	
		text = first .. last
		found = string.find(text, "|c")
	end
	
	return text
end